<?php

namespace DsbNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;

class ParametersIndicatorsController {
    
    protected $crudService;
    
    public function __construct($connection, $environment, $service, $util, $crudService) {
        $this->connection   = $connection;
        $this->environment  = $environment;
        $this->service      = $service;
        $this->util         = $util;
        $this->crudService	= $crudService;
    }
    
    public function unitServices(Request\Filter $request, Response $response) {
        $params = ['NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        $data = $this->crudService->getFilteredDataSet('unitServices', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("unitServices", $data));
    } 
    
    public function showOnDashboard(Request\DataSet $request, Response $response) {
        $rows = $request->getParameters();
        
        try{
            $this->service->beginTransaction();
            
            foreach($rows as $row){
                $params = [
                    "P_CDSERVFILI"  => $row["CDSERVFILI"],
                    "P_CDFILIAL"    => $row["CDFILIAL"],
                    "P_IDINDICADOR" => $row["IDINDICADOR"]
                ];
                $this->service->updateShowOnDashboardStatus($params);
            }
            $this->service->commit();
        }catch(Exception $e){ 
            $this->service->rollback();
            throw $e;
        }
    }
    
    public function saveUnitManager(Request\Row $request, Response $response) {
        $rows = $request->getParameters();
        try{
            $this->service->beginTransaction();
            $params = [
                "P_CDGRUPOPROD"     => $rows["productGrouping"],
                "P_IDCONSXMLCOMFIL" => $rows["xmlSwitch"],
                "P_NRORG"           => $this->environment->getNrorg()
            ];
            $this->service->saveUnitManager($params);
            $this->service->commit();
        }catch(Exception $e){ 
            $this->service->rollback();
            throw $e;
        }
    }
    
    // function updateData($collapseCard, $componentValue1, $componentValue2, $indicador, $update){
    //   foreach($row as $data){
    //         if($data[$collapseCard][$componentValue1] === $indicador && $data[$collapseCard][$componentValue2] === $indicador ){
    //             $params = [
    //                 "P_VRLIMMINIMO"   => isset($data[$componentValue1]) ? $data[$componentValue1] : null,
    //                 "P_VRLIMMETA"     => isset($data[$componentValue2]) ? $data[$componentValue2] : null,
    //                 "P_INDICADOR"     => isset($data[$componentValue2]) ? $data[$componentValue2] : null,
                    
    //                 "P_NRORG" => $this->environment->getNrorg()
    //             ];
    //             $this->service->$update($params);
    //         }
    //     }
    // }
        
    // updateData("AfTrackingCollapseCard", "AfCriticalValue", "AfGoal", 29, "updateAfTrackingTotal");
    // updateData("AfTrackingCollapseCard", "AfAnnualDeliveryGoal", null, 32, "updateAfTrackingAnnual");


    // $params = [
    //     "P_VRLIMMINIMO"   => isset($row["AfCriticalValue"]) ? $row["AfCriticalValue"] : null,
    //     "P_VRLIMMETA"     => isset($row["AfGoal"]) ? $row["AfGoal"] : null,
    //     "P_INDICADOR"     => $row["AfTrackingCollapseCard"]["AfCriticalValue"],
    //     "P_NRORG"         => $this->environment->getNrorg()
    // ];
    // $this->service->updateAfTracking($params);

    public function saveAfTracking(Request\Row $request, Response $response){
        $row = $request->getParameters();
        
        try{
            $this->service->beginTransaction();

            if($row["AfTrackingCollapseCard"]["AfCriticalValue"] === 29 && $row["AfTrackingCollapseCard"]["AfGoal"] === 29 ){
                $params = [
                    "P_VRLIMMINIMO"   => isset($row["AfCriticalValue"]) ? $row["AfCriticalValue"] : null,
                    "P_VRLIMMETA"     => isset($row["AfGoal"]) ? $row["AfGoal"] : null,
                    "P_NRORG"         => $this->environment->getNrorg()
                ];
                $this->service->updateAfTrackingTotal($params);
            }
            if($row["AfTrackingCollapseCard"]["AfAnnualDeliveryGoal"] === 32){
                $params = [
                    "P_VRLIMMETA"     => isset($row["AfAnnualDeliveryGoal"]) ? $row["AfAnnualDeliveryGoal"] : null,
                    "P_NRORG"         => $this->environment->getNrorg()
                ];
                $this->service->updateAfTrackingAnnual($params);
            }
            
            $this->service->commit();
        }catch(Exception $e){
            $this->service->rollback();
            throw $e;
        }
    }
    
    // public function aFTracking(Request\FilterData $request, Response $response) {
    //     var_dump($request);
    //     var_dump($response);
    //     $afValues = $this->service->aFTracking();
    //     var_dump($afValues);
    //     $response->addDataSet(new DataSet("data", $afValues));
        
    // }
}